addHook("PlayerThink", function(player)
	if player.mo.skin != "metalsonic"
		return
	end
	
	if player.cmd.buttons & BT_CUSTOM1
		if not player.RSpActivate
		and not (player.mo.state == S_PLAY_RINGSPARK1)
		and not (player.mo.state == S_PLAY_RINGSPARK2)
		and P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_RINGSPARK1
			player.RSpActivate = true
		end
	else
		player.RSpActivate = false
	end
	
	if player.mo.state == S_PLAY_RINGSPARK2
		if leveltime % 2 == 0
			P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_RINGSPARKAURA)
		end
		
		if P_RandomRange(0, 2) == 2
			S_StartSound(player.mo, sfx_s3k5c)
		end
		
		
		player.normalspeed = 18*FRACUNIT
		player.pflags = $ & ~PF_SPINNING
	else
		if player.normalspeed == 18*FRACUNIT
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end
end)

addHook("PlayerCanDamage", function(p, mo)
	if p.mo.state == S_PLAY_RINGSPARK2
		return true
	end
end)